﻿require("prototypes.scripts.defines") 

local is_valid  = modmashsplinterexplosivemining.util.is_valid
local starts_with  = modmashsplinterexplosivemining.util.starts_with
local print  = modmashsplinterexplosivemining.util.print
local local_on_script_trigger_effect = function(event)
	if event.effect_id == "explosive-water-explosion" and  event.target_position ~= nil then
		local surface = game.surfaces[event.surface_index]
		local entities = surface.find_entities_filtered
		{
			type={"resource"}, 
			area = 
			{
				{
					event.target_position.x-0.5, 
					event.target_position.y-0.5
				}, 
				{
					event.target_position.x+0.5, 
					event.target_position.y+0.5
				}
			}
		}
		local entities = surface.find_entities_filtered
		{
			area = 
			{
				{
					event.target_position.x-0.5, 
					event.target_position.y-0.5
				}, 
				{
					event.target_position.x+0.5, 
					event.target_position.y+0.5
				}
			}
		}
		for k = 1, #entities do local ent = entities[k]
			if is_valid(ent) then
				ent.die()
			end
		end
		local tiles = {}
		for _, pos in pairs{
			{x=event.target_position.x-2.0,y=event.target_position.y-0.5},
			{x=event.target_position.x-2.0,y=event.target_position.y},
			{x=event.target_position.x-2.0,y=event.target_position.y+0.5},

			{x=event.target_position.x-1.5,y=event.target_position.y-1.0},
			{x=event.target_position.x-1.5,y=event.target_position.y-0.5},
			{x=event.target_position.x-1.5,y=event.target_position.y},
			{x=event.target_position.x-1.5,y=event.target_position.y+0.5},
			{x=event.target_position.x-1.5,y=event.target_position.y+1.0},
			{x=event.target_position.x-1.5,y=event.target_position.y+1.5},

			{x=event.target_position.x-1.0,y=event.target_position.y-1.5},
			{x=event.target_position.x-1.0,y=event.target_position.y-1.0},
			{x=event.target_position.x-1.0,y=event.target_position.y-0.5},
			{x=event.target_position.x-1.0,y=event.target_position.y},
			{x=event.target_position.x-1.0,y=event.target_position.y+0.5},
			{x=event.target_position.x-1.0,y=event.target_position.y+1.0},
			{x=event.target_position.x-1.0,y=event.target_position.y+1.5},
			{x=event.target_position.x-1.0,y=event.target_position.y+2.0},

			{x=event.target_position.x-0.5,y=event.target_position.y-2.0},
			{x=event.target_position.x-0.5,y=event.target_position.y-1.5},
			{x=event.target_position.x-0.5,y=event.target_position.y-1.0},
			{x=event.target_position.x-0.5,y=event.target_position.y-0.5},
			{x=event.target_position.x-0.5,y=event.target_position.y},
			{x=event.target_position.x-0.5,y=event.target_position.y+0.5},
			{x=event.target_position.x-0.5,y=event.target_position.y+1.0},
			{x=event.target_position.x-0.5,y=event.target_position.y+1.5},
			{x=event.target_position.x-0.5,y=event.target_position.y+2.0},

			{x=event.target_position.x,y=event.target_position.y-2.0},
			{x=event.target_position.x,y=event.target_position.y-1.5},
			{x=event.target_position.x,y=event.target_position.y-1.0},
			{x=event.target_position.x,y=event.target_position.y-0.5},
			{x=event.target_position.x,y=event.target_position.y},
			{x=event.target_position.x,y=event.target_position.y+0.5},
			{x=event.target_position.x,y=event.target_position.y+1.0},
			{x=event.target_position.x,y=event.target_position.y+1.5},
			{x=event.target_position.x,y=event.target_position.y+2.0},

			{x=event.target_position.x+0.5,y=event.target_position.y-2.0},
			{x=event.target_position.x+0.5,y=event.target_position.y-1.5},
			{x=event.target_position.x+0.5,y=event.target_position.y-1.0},
			{x=event.target_position.x+0.5,y=event.target_position.y-0.5},
			{x=event.target_position.x+0.5,y=event.target_position.y},
			{x=event.target_position.x+0.5,y=event.target_position.y+0.5},
			{x=event.target_position.x+0.5,y=event.target_position.y+1.0},
			{x=event.target_position.x+0.5,y=event.target_position.y+1.5},

			{x=event.target_position.x+1.0,y=event.target_position.y-1.5},
			{x=event.target_position.x+1.0,y=event.target_position.y-1.0},
			{x=event.target_position.x+1.0,y=event.target_position.y-0.5},
			{x=event.target_position.x+1.0,y=event.target_position.y},
			{x=event.target_position.x+1.0,y=event.target_position.y+0.5},
			{x=event.target_position.x+1.0,y=event.target_position.y+1.0},
			{x=event.target_position.x+1.0,y=event.target_position.y+1.5},

			{x=event.target_position.x+1.5,y=event.target_position.y-1.0},
			{x=event.target_position.x+1.5,y=event.target_position.y-0.5},
			{x=event.target_position.x+1.5,y=event.target_position.y},
			{x=event.target_position.x+1.5,y=event.target_position.y+0.5},
			{x=event.target_position.x+1.5,y=event.target_position.y+1.0},
			{x=event.target_position.x+1.5,y=event.target_position.y+1.5},

			{x=event.target_position.x+2.0,y=event.target_position.y-1.0},
			{x=event.target_position.x+2.0,y=event.target_position.y-0.5},
			{x=event.target_position.x+2.0,y=event.target_position.y}
		} do
			if surface.get_tile(pos).collides_with("ground_tile") then
				table.insert(tiles, {name="water-shallow", position=pos}) 
			end 
		end
		surface.set_tiles(tiles)
	end
	
	if event.effect_id == "explosive-deepwater-explosion" and  event.target_position ~= nil then
		local surface = game.surfaces[event.surface_index]
		local entities = surface.find_entities_filtered{type={"resource"}, area = {{event.target_position.x-0.5, event.target_position.y-0.5}, {event.target_position.x+0.5, event.target_position.y+0.5}}}
		local entities = surface.find_entities_filtered{area = {{event.target_position.x-0.5, event.target_position.y-0.5}, {event.target_position.x+0.5, event.target_position.y+0.5}}}
		for k = 1, #entities do local ent = entities[k]
			if is_valid(ent) then
				ent.die()
			end
		end
		surface.set_tiles(			
			{
				{name="deepwater",position={x=event.target_position.x-0.5,y=event.target_position.y-0.5}},
				{name="deepwater",position={x=event.target_position.x-0.5,y=event.target_position.y}},
				{name="deepwater",position={x=event.target_position.x-0.5,y=event.target_position.y+0.5}},
				{name="deepwater",position={x=event.target_position.x,y=event.target_position.y-0.5}},
				{name="deepwater",position={x=event.target_position.x,y=event.target_position.y}},
				{name="deepwater",position={x=event.target_position.x,y=event.target_position.y+0.5}},
				{name="deepwater",position={x=event.target_position.x+0.5,y=event.target_position.y-0.5}},
				{name="deepwater",position={x=event.target_position.x+0.5,y=event.target_position.y}},
				{name="deepwater",position={x=event.target_position.x+0.5,y=event.target_position.y+0.5}}
			}	
		)
	end
	
end

script.on_event(defines.events.on_script_trigger_effect, local_on_script_trigger_effect)