﻿local sounds = require("__base__.prototypes.entity.sounds")
local explosion_animations = require("prototypes.deepwater-explosive.explosion-animations")

data:extend({
	{
		type = "explosion",
		name = "mini-nuke-explosion",
		flags = {"not-on-map"},
		hidden = true,
		icon = "__modmashsplinterexplosivewater__/graphics/icons/deep-water-explosives.png",
		icon_size = 64,
		subgroup = "raw-material",
		order = "b[chemistry]-e[explosives]",	
		height = 0,
		animations = explosion_animations.mini_nuke_explosion(),
		sound = sounds.large_explosion(1.0),
	}
})